proc newVif {} {
   createVif [.f.list size]
   vifs
   selection clear
   .f.list selection set end
}
proc fillinVifs {w} {
   global numVifs vifLocal vifRemote

   $w delete 0 end
   for {set i 0} {$i < $numVifs} {incr i} {
      $w insert end "$vifLocal($i) -> $vifRemote($i)"
   }
}
proc fillinAddrs {w curr} {
   global numVifs vifLocal vifType
 
   $w delete 0 end
   for {set i 0} {$i < $numVifs} {incr i} {
      if {$vifType($i) == "subnet" || $vifType($i) == "querier"} {
         $w insert end "$vifLocal($i)"
         if {$curr == $vifLocal($i)} {
            $w selection set end
         }
      }
   }
}
proc system {} {
   global community
   .f.list delete 0 end
   .m.system configure -state disabled
   .m.vifs configure -state normal
   .m.neighbors configure -state normal
   .m.boundaries configure -state normal
   .m.altnets configure -state normal
   .b.new configure -state disabled
   if {$community == "public"} {
     .b.edit configure -state disabled
   } else {
     .b.edit configure -state normal -command {editSystem}
   }
   .b.delete configure -state disabled
   getSystem
   .f.header configure -text "System Information"
}
proc vifs {} {
   global numVifs community

   .f.list delete 0 end
   .m.system configure -state normal
   .m.vifs configure -state disabled
   .m.neighbors configure -state normal
   .m.boundaries configure -state normal
   .m.altnets configure -state normal

   if {$community == "public"} {
      .b.new configure -state disabled
      .b.edit configure -state disabled
      .b.delete configure -state disabled
   } else {
      .b.new configure -state normal  -command "newVif"
      .b.edit configure -state normal -command {editVif [.f.list curselection]}
      .b.delete configure -state normal -command {deleteVif [.f.list curselection]; vifs}
   }

   getVifs
   .f.list selection set 0
   bind .f.list <Double-Button-1> {
      set host [lindex [selection get] end]
      setRouter
   }
   set numVifs [.f.list size]
}
proc neighbors {} {
   .f.header configure -text "Neighbors"
   .f.list delete 0 end
   .m.system configure -state normal
   .m.vifs configure -state normal
   .m.neighbors configure -state disabled
   .m.boundaries configure -state normal
   .m.altnets configure -state normal
   .b.new configure -state disabled
   .b.edit configure -state disabled
   .b.delete configure -state disabled
   getNeighbors
   .f.list selection set 0
   bind .f.list <Double-Button-1> {
      set host [lindex [selection get] end]
      setRouter
   }
}
proc rmBoundary {idx} {
   global boundaryVif boundaryAddr boundaryMask
   deleteBoundary $boundaryVif($idx) $boundaryAddr($idx) $boundaryMask($idx)
}
proc boundaries {} {
   global community
   .f.header configure -text "Boundaries"
   .f.list delete 0 end
   .m.system configure -state normal
   .m.vifs configure -state normal
   .m.neighbors configure -state normal
   .m.boundaries configure -state disabled
   .m.altnets configure -state normal
   if {$community == "public"} {
      .b.new configure -state disabled
      .b.delete configure -state disabled
   } else {
      .b.new configure -state normal  -command "newBoundary"
      .b.delete configure -state normal -command {rmBoundary [.f.list curselection]; boundaries}
   }
   .b.edit configure -state disabled
   getBoundaries
   .f.list selection set 0
   bind .f.list <Double-Button-1> {}
}
proc altnets {} {
   global community
   .f.header configure -text "AltNets"
   .f.list delete 0 end
   .m.system configure -state normal
   .m.vifs configure -state normal
   .m.neighbors configure -state normal
   .m.boundaries configure -state normal
   .m.altnets configure -state disabled
   if {$community == "public"} {
      .b.new configure -state disabled
      .b.delete configure -state disabled
   } else {
      .b.new configure -state normal  -command "newAltNet"
      .b.delete configure -state normal -command {deleteAltNet [.f.list curselection]; altnets}
   }
   .b.edit configure -state disabled
   getAltNets
   .f.list selection set 0
   bind .f.list <Double-Button-1> {}
}
proc editSystem {} {
   global Description Location Contact
   global sysDescr sysLocation sysContact

   toplevel .e
   wm title .e "Edit System Identification"

   frame .e.f1
   label .e.f1.l -text "Description:"
   entry .e.f1.e -textvariable sysDescr -width 80

   frame .e.f2
   label .e.f2.l -text "Location:"
   entry .e.f2.e -textvariable sysLocation -width 80

   frame .e.f3
   label .e.f3.l -text "Contact:"
   entry .e.f3.e -textvariable sysContact -width 80

   frame .e.b
   button .e.b.submit -text "Submit changes" -command "modifySystem \$sysDescr \$sysLocation \$sysContact; destroy .e"
   button .e.b.abort -text "Abort" -command "destroy .e"

   pack .e.f1 .e.f2 .e.f3 .e.b -anchor w -expand true -fill x
   pack .e.f1.l .e.f2.l .e.f3.l -side left -expand true -fill x
   pack .e.f1.e .e.f2.e .e.f3.e -side left -expand true -fill x
   pack .e.b.submit .e.b.abort -side left -expand true -fill x

   # Set local variables
   set sysDescr    $Description
   set sysLocation $Location
   set sysContact  $Contact

   # Suspend while user interacts there
   grab .e
   tkwait window .e

   system
}
proc editVif {idx} {
   global vifLocal vifMetric vifThresh vifType vifOperState vifAdminState vifRemote vifRate
   global remote metric thresh adminState rate

   if {$idx == ""} { return }
   toplevel .e
   wm title .e "Edit Vif"

   label .e.f1 -text "Vif Index: $idx" -anchor w
   label .e.f2 -text "Type: $vifType($idx)" -anchor w
   label .e.f3 -text "State: $vifOperState($idx)" -anchor w

   frame .e.f4
   label .e.f4.l -text "Local Address:"
   listbox .e.f4.e -width 15 -height 3 -yscrollcommand ".e.f4.s set" 
   scrollbar .e.f4.s -command ".e.f4.e yview"
   fillinAddrs .e.f4.e $vifLocal($idx)
   frame .e.f5
   label .e.f5.l -text "Remote Address:"
   entry .e.f5.e -textvariable remote
   frame .e.f6
   label .e.f6.l1 -text "Metric:"
   entry .e.f6.e1 -textvariable metric -width 3
   label .e.f6.l2 -text "Threshold:"
   entry .e.f6.e2 -textvariable thresh -width 3
   frame .e.f8
   label .e.f8.l -text "Rate Limit:"
   entry .e.f8.e -textvariable rate -width 6
   frame .e.f7
   label .e.f7.l -text "AdminState:"
   radiobutton .e.f7.r1 -text "Enabled" -variable adminState -value active
   radiobutton .e.f7.r2 -text "Disabled" -variable adminState -value notInService
   frame .e.b
   button .e.b.submit -text "Submit changes" -command "modifyVif $idx \[.e.f4.e get active\] \$remote \$metric \$thresh \$rate \$adminState; destroy .e"
   button .e.b.abort -text "Abort" -command "destroy .e"

   pack .e.f1 .e.f2 .e.f3 .e.f4 .e.f5 .e.f6 .e.f8 .e.f7 .e.b -anchor w \
     -expand true -fill x
   pack .e.f4.l .e.f5.l .e.f6.l1 .e.f6.e1 .e.f6.l2 .e.f6.e2 .e.f7.l -side left\
     -expand true -fill x
   pack .e.f4.e .e.f4.s .e.f5.e .e.f7.r1 .e.f7.r2 .e.f8.l .e.f8.e -side left \
     -expand true -fill x
   pack .e.b.submit .e.b.abort -side left -expand true -fill x

   # Set local variables
   set local $vifLocal($idx)
   set remote $vifRemote($idx)
   set metric $vifMetric($idx)
   set thresh $vifThresh($idx)
   set rate $vifRate($idx)
   set adminState $vifAdminState($idx)

   # Suspend while user interacts there
   grab .e
   tkwait window .e

   vifs
   selection clear
   .f.list selection set $idx
}
proc newBoundary {} {
   toplevel .e
   wm title .e "Create Boundary"
   set vif 0
   set addr 239.0.0.0
   set mask 255.255.255.0

   frame .e.f1
   label .e.f1.l -text "Vif:"
   listbox .e.f1.e -width 40
   fillinVifs .e.f1.e
   .e.f1.e selection set 0
   frame .e.f2
   label .e.f2.l -text "Address:"
   entry .e.f2.e -textvariable addr
   frame .e.f3
   label .e.f3.l -text "Mask:"
   entry .e.f3.e -textvariable mask

   frame .e.b
   button .e.b.submit -text "Create" -command {createBoundary [.e.f1.e curselection] $addr $mask; destroy .e}
   button .e.b.abort -text "Abort" -command "destroy .e"

   pack .e.f1 .e.f2 .e.f3 .e.b -expand true -fill x
   pack .e.b.submit .e.b.abort -side left -expand true -fill x
   pack .e.f1.l .e.f1.e -side left -expand true -fill x
   pack .e.f2.l .e.f2.e -side left -expand true -fill x
   pack .e.f3.l .e.f3.e -side left -expand true -fill x

   # Suspend while user interacts there
   grab .e
   tkwait window .e

   boundaries
   selection clear
   .f.list selection set end
}
proc newAltNet {} {
   toplevel .e
   wm title .e "Create AltNet"
   set vif 40
   set addr 0
   set mask 0

   frame .e.f1
   label .e.f1.l -text "Vif:"
   listbox .e.f1.e -width 40
   fillinVifs .e.f1.e
   .e.f1.e selection set 0
   frame .e.f2
   label .e.f2.l -text "Address:"
   entry .e.f2.e -textvariable addr
   frame .e.f3
   label .e.f3.l -text "Mask:"
   entry .e.f3.e -textvariable mask

   frame .e.b
   button .e.b.submit -text "Create" -command {createAltNet [.e.f1.e curselect
ion] $addr $mask; destroy .e}
   button .e.b.abort -text "Abort" -command "destroy .e"

   pack .e.f1 .e.f2 .e.f3 .e.b -expand true -fill x
   pack .e.b.submit .e.b.abort -side left -expand true -fill x
   pack .e.f1.l .e.f1.e -side left -expand true -fill x
   pack .e.f2.l .e.f2.e -side left -expand true -fill x
   pack .e.f3.l .e.f3.e -side left -expand true -fill x

   # Suspend while user interacts there
   grab .e
   tkwait window .e

   altnets
   selection clear
   .f.list selection set end
}
proc setRouter {} {
   global host 
   openSession $host
   wm title . "mconfig $host"
#   .h.router configure -text "$host"
   vifs
}
proc outputRow {str} {
   .f.list insert end $str
}
proc outputHeader {str} {
   .f.header configure -text $str
}
proc menu {} {
   global host port community addronly
   toplevel .t
   wm transient .t
   wm title .t "@mconfig"
   button .t.dismiss -text "Dismiss" -command ".b.menu configure -state normal; destroy .t"
   frame .t.f1 -relief groove -bd 2
   radiobutton .t.f1.name -text "Display hostnames" -variable addronly -value 0
   radiobutton .t.f1.addr -text "Display IP addresses" -variable addronly -value 1
   pack .t.f1.name .t.f1.addr -anchor w
   
   frame .t.f2 -relief groove -bd 2

   frame .t.f2.f1 
   label .t.f2.f1.l -text "Host:"
   entry .t.f2.f1.e -relief sunken -bd 2 -textvariable host
   bind .t.f2.f1.e <Return> {setRouter}
   pack .t.f2.f1.l .t.f2.f1.e -side left -padx 1m -fill x -expand true

   frame .t.f2.f2
   label .t.f2.f2.l -text "Port:"
   entry .t.f2.f2.e -relief sunken -bd 2 -textvariable port
   bind .t.f2.f2.e <Return> {setRouter}
   pack .t.f2.f2.l .t.f2.f2.e -side left -padx 1m -fill x -expand true

   frame .t.f2.f3 
   label .t.f2.f3.l -text "Community:"
   entry .t.f2.f3.e -relief sunken -bd 2 -textvariable community -show {*}
   bind .t.f2.f3.e <Return> {setRouter}
   pack .t.f2.f3.l .t.f2.f3.e -side left -padx 1m -fill x -expand true

   pack .t.f2.f1 .t.f2.f2 .t.f2.f3 -anchor w -expand true -fill x
   pack .t.f1 .t.f2 .t.dismiss -side top -expand true -fill x
   .b.menu configure -state disabled
}

# Initialize variables
#set addronly 0
#set port 161
#set community "public"
set font "-adobe-courier-medium-r-normal--14-*-*-*-m-*-*-*"

# Create initial layout
frame .h 
label .h.versid -text "UM/Merit mconfig v1.0"
#label .h.router 
frame .m -relief groove -bd 2
button .m.system     -text "System"     -command "system" -pady 1
button .m.vifs       -text "VIFs"       -command "vifs" -pady 1
button .m.neighbors  -text "Neighbors"  -command "neighbors" -pady 1
button .m.boundaries -text "Boundaries" -command "boundaries" -pady 1
button .m.altnets    -text "AltNets"    -command "altnets" -pady 1
frame .f 
label .f.header -font $font -justify left
listbox .f.list -height 10 -width 80 -relief sunken \
 -yscrollcommand ".f.scroll set" -font $font
scrollbar .f.scroll -command ".f.list yview"
frame .b
button .b.new    -text "New"    -command "new" -pady 1
button .b.edit   -text "Edit"   -command "edit" -pady 1
button .b.delete -text "Delete" -command "delete" -pady 1
button .b.menu   -text "Menu"   -command "menu" -pady 1
button .b.quit   -text "Quit"   -command "exit" -pady 1

pack .h .m .f .b -side top -expand true -fill x
pack .h.versid -side top -anchor w
pack .m.system .m.vifs .m.neighbors .m.boundaries .m.altnets -side left \
 -expand true -fill x
pack .f.header -side top -anchor w
pack .f.list .f.scroll -side left -fill y
pack .b.new .b.edit .b.delete .b.menu .b.quit -side left \
 -expand true -fill x

# Start at vifs display
setRouter
